package com.example.app.jmix.playground.playground.entity;

import java.util.List;
import java.util.UUID;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.DependsOnProperties;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import io.jmix.core.metamodel.annotation.JmixProperty;

@JmixEntity
@Table(name = "PLGRND_CUSTOMER")
@Entity(name = "plgrnd_Customer")
public class Customer
{
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @InstanceName
    @Column(name = "NAME")
    private String name;

    @OneToMany(mappedBy = "customer")
    private List<Context> contexts;

    @DependsOnProperties({ "contexts" })
    @JmixProperty
    public Context getLatestContext()
    {
        final Context result;
        if (contexts == null || contexts.isEmpty())
        {
            result = null;
        }
        else
        {
            result = contexts.get(0);
        }
        return result;
    }

    public List<Context> getContexts()
    {
        return contexts;
    }

    public void setContexts(List<Context> contexts)
    {
        this.contexts = contexts;
    }

    public String getName()
    {
        return name;
    }

    public void setName(String name)
    {
        this.name = name;
    }

    public UUID getId()
    {
        return id;
    }

    public void setId(UUID id)
    {
        this.id = id;
    }
}