package com.example.app.jmix.playground.playground.screen.main;

import org.springframework.beans.factory.annotation.Autowired;

import io.jmix.ui.ScreenTools;
import io.jmix.ui.component.AppWorkArea;
import io.jmix.ui.component.Button;
import io.jmix.ui.component.Window;
import io.jmix.ui.component.mainwindow.Drawer;
import io.jmix.ui.icon.JmixIcon;
import io.jmix.ui.navigation.Route;
import io.jmix.ui.screen.Screen;
import io.jmix.ui.screen.Subscribe;
import io.jmix.ui.screen.UiController;
import io.jmix.ui.screen.UiControllerUtils;
import io.jmix.ui.screen.UiDescriptor;

import com.example.app.jmix.playground.playground.JmixPlaygroundApplication;

@UiController(MainScreen.UI_CONTROLLER)
@UiDescriptor(MainScreen.UI_DESCRIPTOR)
@Route(path = MainScreen.ROUTE_PATH, root = true)
public class MainScreen extends Screen implements Window.HasWorkArea
{
    /**
     * Defines the navigation route path.
     */
    public static final String ROUTE_PATH = "main";

    /**
     * Defines the UI controller name.
     */
    public static final String UI_CONTROLLER = JmixPlaygroundApplication.SCREEN_PREFIX + "MainScreen";

    /**
     * Defines the UI descriptor file name.
     */
    public static final String UI_DESCRIPTOR = "main-screen.xml";

    @Autowired
    private ScreenTools screenTools;

    @Autowired
    private AppWorkArea workArea;

    @Autowired
    private Drawer drawer;

    @Autowired
    private Button collapseDrawerButton;

    @Override
    public AppWorkArea getWorkArea()
    {
        return workArea;
    }

    @Subscribe("collapseDrawerButton")
    private void onCollapseDrawerButtonClick(final Button.ClickEvent anEvent)
    {
        drawer.toggle();
        if (drawer.isCollapsed())
        {
            collapseDrawerButton.setIconFromSet(JmixIcon.CHEVRON_RIGHT);
        }
        else
        {
            collapseDrawerButton.setIconFromSet(JmixIcon.CHEVRON_LEFT);
        }
    }

    @Subscribe
    public void onAfterShow(final AfterShowEvent anEvent)
    {
        screenTools.openDefaultScreen(UiControllerUtils.getScreenContext(this).getScreens());

        screenTools.handleRedirect();
    }
}
