package com.example.app.jmix.playground.playground.security;

import java.util.Collection;

import org.springframework.context.annotation.Primary;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.stereotype.Component;

import com.example.app.jmix.playground.playground.JmixPlaygroundApplication;
import com.example.app.jmix.playground.playground.entity.User;

import io.jmix.securitydata.user.AbstractDatabaseUserRepository;

@Primary
@Component(JmixPlaygroundApplication.PROJECT_ID + "_UserRepository")
public class DatabaseUserRepository extends AbstractDatabaseUserRepository<User>
{
    @Override
    protected Class<User> getUserClass()
    {
        return User.class;
    }

    @Override
    protected void initSystemUser(final User aSystemUser)
    {
        Collection<GrantedAuthority> authorities = getGrantedAuthoritiesBuilder().addResourceRole(FullAccessRole.CODE)
                        .build();
        aSystemUser.setAuthorities(authorities);
    }

    @Override
    protected void initAnonymousUser(final User anAnonymousUser)
    {

    }
}